# place N chess queens on an NxN chessboard such that no queen
# can take another. Solution by Cameron.

fn compare (row col used_rows n)
{
  if (equ(used_rows {}))
  {
    return(1)
  }
  elsif (equ(row head(used_rows)))
  {
    return(0)
  }
  elsif (equ( abs(sub(row head(used_rows))) abs(sub(col n))))
  {
    return(0)
  }
  else
  {
    return (compare(row col tail(used_rows) add(n 1)))
  }
}

fn queens (row col used_rows n)
{
  if ( gtn(row n) )
  {
    return (0)
  }
  elsif ( gtn(col n) )
  {
    return (used_rows)
  }
  elsif (compare (row col used_rows 1))
  {
    if (queens(1 add(col 1) add_tail(row used_rows) n))
    {
      return (last_result())
    } else
    {
      queens(add(row 1) col used_rows n)
    }
  }
  else
  {
    queens(add(row 1) col used_rows n)
  }
}

fn nqueens(n) {
  if ( queens (1 1 {} n) ) { return (last_result())}
  else { return ("no solution") } }


display("n=8, solution=" nqueens (8) "\n")
display("n=4, solution=" nqueens (4) "\n")
display("n=2, solution=" nqueens (2) "\n")
display("n=1, solution=" nqueens (1) "\n")
display("n=0, solution=" nqueens (0) "\n")
